﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Text;
using System.Xml.Linq;

namespace ConsoleAppMeituanTTS
{
    internal class ConfigHelper
    {

        /// <summary>
        /// 获取配置文件变量
        /// </summary>
        /// <param name="var_str"></param>
        /// <returns></returns>
        public static string func_get_viki_sys_config_by_var(string var_str)
        {
            try
            {
                string xmlPath;
                xmlPath = AppDomain.CurrentDomain.BaseDirectory;
                Directory.CreateDirectory(xmlPath);
                xmlPath = xmlPath + @"conf/" + "viki_sys_config.xml";
                XDocument xDoc = XDocument.Load(xmlPath);
                return xDoc.Element("viki_config").Element(var_str).Value.ToString();
            }
            catch (Exception ex)
            {
                func_WriteLog(ex.Message.ToString());
            }

            return "default";

        }

        /// <summary>
        /// 返回调试状态
        /// </summary>
        /// <returns></returns>
        public static bool func_get_viki_debug_status()
        {
            if ("on" == func_get_viki_sys_config_by_var("DEBUG"))
            {
                return true;
            }
            return false;
        }

        /// <summary>
        /// 写入日志
        /// </summary>
        /// <param name="strMsg"></param>
        /// <returns></returns>
        public static int func_WriteLog(string strMsg)
        {

            string sFilePath = AppDomain.CurrentDomain.BaseDirectory + @"/log";
            string sFileName = DateTime.Now.ToString("yyyy-MM-dd") + ".log";
            sFileName = sFilePath + "/" + sFileName;

            if (!Directory.Exists(sFilePath))//验证路径是否存在
            {
                Directory.CreateDirectory(sFilePath);
            }

            FileStream fs;
            StreamWriter sw;
            if (File.Exists(sFileName))
            {
                fs = new FileStream(sFileName, FileMode.Append, FileAccess.Write);
            }
            else
            {
                fs = new FileStream(sFileName, FileMode.Create, FileAccess.Write);
            }

            sw = new StreamWriter(fs);
            sw.WriteLine(DateTime.Now.ToString("yyyy-MM-dd HH-mm-ss") + " | " + strMsg);
            sw.Close();
            fs.Close();

            return 1;
        }


    }
}
