﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Web;
using System.Xml.Linq;

namespace WinFormsAppMtuanTTS_Demo
{
    internal class Meituan
    {
        //Meituan.HttpDownloadFile("c.wav", strTTS_MAX_DOWN_TIME, strRequestToken, Guid.NewGuid().ToString(), "meifannan", "后来在网上找到了相关的解决办法，在哪里找到的忘了。记得是查看了.NET的源码，写出了如下代码来实现的", 50,100,8000);

        public static string GetAppToken(string AppKey, string SecretKey) {


            IDictionary<string, string> parameters = new Dictionary<string, string>();

            parameters.Add("grant_type", HttpUtility.UrlEncode("client_credentials"));
            
            parameters.Add("client_id", HttpUtility.UrlEncode(AppKey));
            
            parameters.Add("client_secret", HttpUtility.UrlEncode(SecretKey));

            System.Net.HttpWebResponse res = Meituan.CreatePostHttpResponse("https://auth-ai.meituan.com/oauth/v2/token", parameters, 3000, null, null);

            string mes = Meituan.GetResponseString(res);

            JObject jo = (JObject)JsonConvert.DeserializeObject(mes);

            int str_request_status = Convert.ToInt32(jo["errcode"].ToString());

            if (str_request_status == 0) {
                return jo["data"]["access_token"].ToString();
            }

            return "error";

        }


        /// <summary>
        /// Http下载文件
        /// </summary>
        public static string HttpDownloadFile(string path, int Timeout, string Token, string session_id, string voice_name, string text, string speed, string volume, int sample_rate )
        {
            string url = "https://tts.sankuai.com/api/v1/tts?";

            url = url + "session_id=" + session_id + "&voice_name=" + voice_name + "&text=" + text + "&speed=" + speed.ToString() + "&volume=" + volume.ToString() + "&sample_rate=" + sample_rate.ToString();

            // 设置参数
            HttpWebRequest request = WebRequest.Create(url) as HttpWebRequest;
            request.Method = "GET";
            request.ContentType = "text/html;charset=UTF-8";
            request.UserAgent = null;
            request.Timeout = Timeout;
            request.Headers.Set("Token", Token);

            //发送请求并获取相应回应数据
            HttpWebResponse response = request.GetResponse() as HttpWebResponse;
            
            //直到request.GetResponse()程序才开始向目标网页发送Post请求
            Stream responseStream = response.GetResponseStream();

            //创建本地文件写入流
            Stream stream = new FileStream(path, FileMode.Create);

            byte[] bArr = new byte[1024];
            int size = responseStream.Read(bArr, 0, (int)bArr.Length);

            while (size > 0)
            {
                stream.Write(bArr, 0, size);
                size = responseStream.Read(bArr, 0, (int)bArr.Length);
            }
            stream.Close();
            responseStream.Close();
            return path;
        }

        ///
        /// Get请求
        /// 
        /// 
        /// 字符串
        public static string GetHttpResponse(string url, int Timeout, string Token, string session_id, string voice_name, string text , string speed, string volume , string sample_rate)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
            request.Method = "GET";
            request.ContentType = "text/html;charset=UTF-8";
            request.UserAgent = null;
            request.Timeout = Timeout;
            request.Headers.Set("Token", Token);

            url = url + "?session_id=" + session_id + "&voice_name=" + voice_name + "&text=" + text + "&speed=" + speed + "&volume=" + volume + "&sample_rate=" + sample_rate;


            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            Stream myResponseStream = response.GetResponseStream();
            StreamReader myStreamReader = new StreamReader(myResponseStream, Encoding.GetEncoding("utf-8"));
            string retString = myStreamReader.ReadToEnd();
            myStreamReader.Close();
            myResponseStream.Close();

            return retString;
        }

        /// 创建POST方式的HTTP请求  
        public static HttpWebResponse CreatePostHttpResponse(string url, IDictionary<string, string> parameters, int timeout, string userAgent, CookieCollection cookies)
        {
            HttpWebRequest request = null;
            //如果是发送HTTPS请求  
            if (url.StartsWith("https", StringComparison.OrdinalIgnoreCase))
            {
                request = WebRequest.Create(url) as HttpWebRequest;
            }
            else
            {
                request = WebRequest.Create(url) as HttpWebRequest;
            }
            request.Method = "POST";
            request.ContentType = "application/x-www-form-urlencoded";

            //设置代理UserAgent和超时
            //request.UserAgent = userAgent;
            //request.Timeout = timeout; 

            if (cookies != null)
            {
                request.CookieContainer = new CookieContainer();
                request.CookieContainer.Add(cookies);
            }
            //发送POST数据  
            if (!(parameters == null || parameters.Count == 0))
            {
                StringBuilder buffer = new StringBuilder();
                int i = 0;
                foreach (string key in parameters.Keys)
                {
                    if (i > 0)
                    {
                        buffer.AppendFormat("&{0}={1}", key, parameters[key]);
                    }
                    else
                    {
                        buffer.AppendFormat("{0}={1}", key, parameters[key]);
                        i++;
                    }
                }
                byte[] data = Encoding.ASCII.GetBytes(buffer.ToString());
                using (Stream stream = request.GetRequestStream())
                {
                    stream.Write(data, 0, data.Length);
                }
            }
            string[] values = request.Headers.GetValues("Content-Type");
            return request.GetResponse() as HttpWebResponse;
        }


        /// <summary>
        /// 获取请求的数据
        /// </summary>
        public static string GetResponseString(HttpWebResponse webresponse)
        {
            using (Stream s = webresponse.GetResponseStream())
            {
                StreamReader reader = new StreamReader(s, Encoding.UTF8);
                return reader.ReadToEnd();

            }
        }

    }
}
